function C_prob = CouplingMatrix(Hs,Tp)

% Create vector of unique observed values
Tp_unique = unique(Tp);
Hs_unique = unique(Hs);

% Lengths
n_unique_Hs = length(Hs_unique);
n_unique_Tp = length(Tp_unique);

% Preallocate 
C_events = zeros(n_unique_Hs,n_unique_Tp);
C_prob = zeros(n_unique_Hs,n_unique_Tp);

% --------------------- Count Occurences ----------------------------------
for kk = 1:n_unique_Hs
    % Find all indexes in metocean data for each unique Hs
    index = find(Hs == Hs_unique(kk));
    
    % Count number of occurences of each unique Tp for each  unique Hs
    for ii = 1:length(index)
        for jj = 1:n_unique_Tp
            if Tp(index(ii)) == Tp_unique(jj)
                C_events(kk,jj) = C_events(kk,jj) + 1;
                break;
            end
        end
    end
end

%Normalize to probabilty matrix
for ii = 1:n_unique_Hs
    C_prob(ii,:) = C_events(ii,:)/sum(C_events(ii,:)); 
end
end
