function overallResults = over_all_mean_variance(HsObs,TpObs,Ysim,num_rep)

% Over-all mean and variance of observed values
meanObsHs = mean(HsObs);
varObsHs = var(HsObs);
meanObsTp = mean(TpObs);
varObsTp = var(TpObs);
cov_obs = cov(HsObs,TpObs);
covObs = cov_obs(1,2);

meanSimHs = mean(mean(Ysim(:,1,:)));
varSimHs = mean(var(Ysim(:,1,:)));
meanSimTp = mean(mean(Ysim(:,2,:)));
varSimTp = mean(var(Ysim(:,2,:)));

cov_sum = zeros(2,2);
for ii = 1:num_rep
    cov_syn = cov(Ysim(:,1,ii),Ysim(:,2,ii));
    cov_sum = cov_sum + cov_syn;
end

cov_sim = cov_sum/num_rep;
covSim = cov_sim(1,2);

% Store overall results
overallResults = [meanSimHs varSimHs meanSimTp varSimTp covSim; meanObsHs ...
    varObsHs meanObsTp varObsTp covObs];
end