function [aboveBin, belowBin] = persistence(series,step_length)
% CAUTION: The function intersections.m behaves strange for some 
% threshold values which will result in erroerous results. 


% Length of series
nSeries = length(series);

% Duration of smallest weather windows
binSize = 6;
% Number of weather windows
numBins = 60;
% Number of steps for Hs
%Hs_step = 20;

% Initialize vectors for intersection determination
x1 = 1:nSeries;
x2 = 1:nSeries;
y2(1,:) = series;

% Value vector
valVec = 1:0.25:4;

% Preallocation
belowBin = zeros(numBins,length(valVec));
aboveBin = zeros(numBins,length(valVec));

% Access and Waiting 
for kk = 1:length(valVec)

% Treshold vector, 0.999 to avoid counting intersection points
y1 = ones(1,nSeries)*valVec(kk)*0.999;

% Find intersections
[x0,y0] = intersections(x1,y1,x2,y2);
%% ----------------------- Threshold Windows -----------------------------

% -------------------------- Below Treshold ------------------------------
if valVec(kk) <= series(1) % Window starts later in series 
    belowTresh = zeros(1,floor(length(x0)/2));
    for ii = 1:1:floor(length(x0)/2)
        belowTresh(ii) = x0(2*ii)-x0(2*ii-1); % Length of WWs
    end
    if valVec(kk) >= series(end)
        belowTresh(end+1) = length(series)-x0(end);
    end
else % Window starts at begining of series
    belowTresh = zeros(1,ceil(length(x0)/2));
    belowTresh(1) = x0(1);
    for ii = 1:ceil(length(x0)/2)-1
        belowTresh(ii+1) = x0(2*ii+1)-x0(2*ii); % Length of WWs
    end
    if valVec(kk) >= series(end)
        belowTresh(end+1) = length(series)-x0(end);
    end
end 

% ------------------------ Above Treshold ---------------------------------
if valVec(kk) <= series(1) % Window starts at begining of series 
    aboveTresh = zeros(1,ceil(length(x0)/2));
    aboveTresh(1) = x0(1);
    for ii = 1:ceil(length(x0)/2)-1
        aboveTresh(ii+1) = x0(2*ii+1)-x0(2*ii); % Length of WWs
    end
    if valVec(kk) <= series(end)
        aboveTresh(end+1) = length(series)-x0(end);
    end
else % Window starts later in series  
    aboveTresh = zeros(1,floor(length(x0)/2));
    for ii = 1:1:floor(length(x0)/2)
        aboveTresh(ii) = x0(2*ii)-x0(2*ii-1); % Length of WWs
    end
    if valVec(kk) <= series(end)
        aboveTresh(end+1) = length(series)-x0(end);
    end
end 

%% ----------------- Time Above and Below Threshold -----------------------
% Transform time steps to real time
belowTresh = belowTresh*step_length;
aboveTresh = aboveTresh*step_length;

% Time BELOW Threshold Matrice
for ii = 1:length(belowTresh)
    for jj = 1:numBins 
            belowBin(jj,kk) = belowBin(jj,kk) + floor(belowTresh(ii)/(binSize*jj));
    end
end

% Time ABOVE Threshold Matrice
for ii = 1:length(aboveTresh)
    for jj = 1:numBins
            aboveBin(jj,kk) = aboveBin(jj,kk) + floor(aboveTresh(ii)/(binSize*jj));
    end
end

end
end