%------- creating scatter diagram using archived Hs and randomized Tp----------

% This function was used with permission from its author Endre Sandvik.

function scatterD = scatterDiagram(Hs, Tp)
%%
%Defining different variables used in the program
n = length(Hs);
a = 41;
b = 27;

%Creating scatter diagram matrix
scatterD = zeros(a,b);
scatterD(1:39,1) = 0:0.5:19;
scatterD(1,1:25) = 0:1:24;

%%
%For-loop for sorting data into classes
for i = 1:n
    
    %Sorting Hs into classes of 0.5
    diff = Hs(i) - floor(Hs(i));
    
    if diff >= 0.75
        
        Hs(i)=ceil(Hs(i));
        
    elseif diff >= 0.25 && diff < 0.75 
        
        Hs(i) = floor(Hs(i)) + 0.5;
        
    else
        
        Hs(i) = max([floor(Hs(i)) 0.5]);
        
    end
    
    
    %Sorting Tp into classes of 1
    diffTp = Tp(i) - floor(Tp(i));
    
    if diffTp >= 0.5
        
        Tp(i)=ceil(Tp(i));
        
    else
        Tp(i) = max([floor(Tp(i)) 1]);
        
    end
end
%%
for i = 1:n
   
    if Hs(i) < 19 && Tp(i) < 24
   %Assigning the sea state to the correct location in the scatter diagram
   scatterD(1+2*Hs(i),1+Tp(i)) = scatterD(1+2*Hs(i),1+Tp(i)) + 1; 
   
   %Adding 1 to the count of Hs
   scatterD(1+2*Hs(i),b-1) = scatterD(1+2*Hs(i),b-1) + 1;
   
   %Adding 1 to the count of Tp
   scatterD(a-1,1+Tp(i)) = scatterD(a-1,1+Tp(i)) + 1;
    end

end
%%
%Counting cumulative i-values
for i = 2:a-1
    
    scatterD(i,b) = scatterD(i-1,b) + scatterD(i,b-1);
    
end
    
for i = 2:b-1
    
    scatterD(a,i) = scatterD(a,i-1) + scatterD(a-1,i);
    
end
%% 
end


    
    